# db电话簿
## 服务器配置
```js
// 安装venv
python3 -m venv venv
// 启动venv
. venv/bin/activate
// 升级pip
pip install --upgrade pip
// 根据依赖文件安装环境
pip install -r requirements.txt
// 设置全局变量
export FLASK_APP=phonebook.py
export FLASK_ENV=development
flask run --host=0.0.0.0 -p 80
// 启动永久服务
gunicorn phonebook:app -c gunicorn.conf.py
// 查看已启动服务
pstree -ap|grep gunicorn
// 关闭某服务
kill (pid)
//关闭venv
deactivate 
// 创建当前环境的依赖文件
pip freeze > requirements.txt
```

## 错误码
/login
450：没用手机号登录过教务
422：账号或者密码错误
400：数据不合法
510：数据库查询失败
511：教务挂了
512：未注册
/sign
400：数据不合法
510：数据库插入失败
511：已注册过，无需再次注册
512：数据库查询失败
/del
400：数据不合法
510：数据库删除失败
/update
400：数据不合法
510：数据库覆写失败
/get
400：数据不合法
510：数据库查询失败
511：用户认证失败
512：数据库查询失败

docker run -it --name beta -v /root/data/phonebook:/app -p 127.0.0.1:6000:80 --network=lacus lacus/flask_env /bin/sh